-- Steyr 8130
-- @author  Mev01
-- @date  11/04/09

Steyr8130 = {};

function Steyr8130.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function Steyr8130:load(xmlFile)

    


    self.rundumleuchtenAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.rundumleuchten#count"),0);
    self.rundumleuchtenKey = getXMLString(xmlFile, "vehicle.rundumleuchten#key");
    self.rundumleuchtenAn = false;
    self.rundumleuchten = {};
    for i=1, self.rundumleuchtenAnz do
        local objname = string.format("vehicle.rundumleuchten.light" .. "%d",i);
        self.rundumleuchten[i] = {};
        self.rundumleuchten[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.rundumleuchten[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.rundumleuchten[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.rundumleuchten[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.rundumleuchten[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.rundumleuchten[i].emit and self.rundumleuchten[i].source ~= nil then
           setVisibility(self.rundumleuchten[i].source, false);
        end;
    end;


    
	self.exhaustParticleSystems2 = {};
    local psName = "vehicle.exhaustParticleSystemExtra1";
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems2, psName, self.rootNode, false)
	
	self.exhaustParticleSystems3 = {};
    local psName = "vehicle.exhaustParticleSystemExtra2";
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems3, psName, self.rootNode, false)
	
	self.exhaustParticleSystems4 = {};
    local psName = "vehicle.exhaustParticleSystemExtra3";
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems4, psName, self.rootNode, false)
	
	self.exhaustParticleSystems5 = {};
    local psName = "vehicle.exhaustParticleSystemExtra4";
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems5, psName, self.rootNode, false)


	
	self.numTwinWheels = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.twinWheels#count"), 0);
    self.twinWheels = {};
    for i=1, self.numTwinWheels do
        local twinWheelnamei = string.format("vehicle.twinWheels.twinWheel" .. "%d", i);
        self.twinWheels[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, twinWheelnamei .. "#index"));
        setVisibility(self.twinWheels[i], false);
    end;

	

	

      self.twinWheelsActive= false;
       self.worklightsActive = false;



end;

function Steyr8130:delete()
end;

function Steyr8130:mouseEvent(posX, posY, isDown, isUp, button)
end;


function Steyr8130:keyEvent(unicode, sym, modifier, isDown)
	--Steyr8130:superClass().keyEvent(self, unicode, sym, modifier, isDown);

     

if isDown and sym == Input.KEY_6 then 
		self.twinWheelsActive = not self.twinWheelsActive;
	end;


    if isDown and sym == Input.KEY_0 then
		self.helpPanel = not self.helpPanel;
	end;

    if self.isEntered then
      if self.rundumleuchtenKey ~= nil then
         if isDown and sym == Input[self.rundumleuchtenKey] then
           self.rundumleuchtenAn = not self.rundumleuchtenAn;
           for i=1, self.rundumleuchtenAnz do
             setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
           end;
         end;
      end;
    end;
end;

function Steyr8130:update(dt)

	--if self.isEntered then
		--if self.attachedTrailer and self.lastSpeed*3600 > 2 and self.lastSpeed*3600 < 20 then
			--Utils.setEmittingState(self.exhaustParticleSystems2, true);
	--	end;
	--	if not self.attachedTrailer or not self.motor.speedLevel == 0 or self.lastSpeed*3600 < 2 or self.lastSpeed*3600 > 20 then
	--		Utils.setEmittingState(self.exhaustParticleSystems2, false);
	--	end;
	--	if self.attachedTrailer and self.lastSpeed*3600 > 20 then
	--		Utils.setEmittingState(self.exhaustParticleSystems3, true);
	--	end;
	--	if not self.attachedTrailer or self.lastSpeed*3600 < 20 then
	--		Utils.setEmittingState(self.exhaustParticleSystems3, false);
	--	end;
	--	if not self.attachedTrailer and self.lastSpeed*3600 > 2 and self.lastSpeed*3600 < 20 then
	--		Utils.setEmittingState(self.exhaustParticleSystems4, true);
	--	end;
	--	if not self.attachedTrailer and self.lastSpeed*3600 < 2 or self.lastSpeed*3600 > 20 then
	--		Utils.setEmittingState(self.exhaustParticleSystems4, false);
	--	end;
		
	--	if not self.attachedTrailer and self.lastSpeed*3600 > 20 then
	--		Utils.setEmittingState(self.exhaustParticleSystems5, true);
	--	end;
	--	if not self.attachedTrailer and self.lastSpeed*3600 < 20 then
	--		Utils.setEmittingState(self.exhaustParticleSystems5, false);
	--	end;
	--end;
	




	if self.isEntered then
		if self.rundumleuchtenAn == true then
		setVisibility(self.rullight, true);
	else
		setVisibility(self.rullight, false);
	    end;
    	end;



  if self.isEntered then
    if self.rundumleuchtenAnz > 0 then
      if self.rundumleuchtenAn then
        for i=1, self.rundumleuchtenAnz do
          rotate(self.rundumleuchten[i].rotNode, 0, dt*self.rundumleuchten[i].speed, 0);
        end;
      end;
    end;
  end;



if g_currentMission.currentVehicle ~= nil and g_currentMission.currentVehicle == self then
  if getInputAxis(Input.AXIS_Y) < 0 or self.motor.speedLevel ~= 0 then
setRotation(self.reversierer, 0, 0, Utils.degToRad(45));
     elseif getInputAxis(Input.AXIS_Y) > 0 then 
setRotation(self.reversierer, 0, 0, Utils.degToRad(-45));
     else
     setRotation(self.reversierer,0,0,0);
  end;




  if getInputAxis(Input.AXIS_Y) < 0 or self.motor.speedLevel ~= 0 then
setRotation(self.gaspedal,Utils.degToRad(19), 0, 0);
     elseif getInputAxis(Input.AXIS_Y) > 0 then 
setRotation(self.gaspedal,Utils.degToRad(19), 0, 0);
     else
     setRotation(self.gaspedal,0,0,0);
  end;

  if getInputAxis(Input.AXIS_Y) == 0 then
setRotation(self.brake,Utils.degToRad(-10), 0, 0);
     else
     setRotation(self.brake,0,0,0);
  end;
	end;


 

	if self.twinWheelsActive then
		for i=1, self.numTwinWheels do
			local twinWheel = self.twinWheels[i];
			setVisibility(twinWheel, self.twinWheelsActive);
		end;
	else
		for i=1, self.numTwinWheels do
			local twinWheel = self.twinWheels[i];
			setVisibility(twinWheel, self.twinWheelsActive, false);
		end;
	end;



	
	if self.translationMax ~= nil then
		local x, y, z = getTranslation(self.translationPart.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax);
        setTranslation(self.translationPart.node, unpack(newTrans));
	end;     

 
end;

function Steyr8130:onLeave()
    self.rundumleuchtenAn = false;
    for i=1, self.rundumleuchtenAnz do
       setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
	Steerable.onLeave(self);
	end;
	

	Utils.setEmittingState(self.exhaustParticleSystems2, false);
	Utils.setEmittingState(self.exhaustParticleSystems3, false);
	Utils.setEmittingState(self.exhaustParticleSystems4, false);
	Utils.setEmittingState(self.exhaustParticleSystems5, false);

end;


function Steyr8130:draw()

   if self.isEntered then
		if not self.helpPanel then
			renderText(0.8335, 0.87, 0.02, "Taste 0: Info");

		else
			renderText(0.8335, 0.87, 0.02, "Taste 0: Info Abschalten");

		end;
		if self.helpPanel then
			renderText(0.7415, 0.33, 0.025, "Steyr8130 By Logiasus Tuning");
			renderText(0.7635, 0.305, 0.02, "Taste 6 Doppelbereifung");
            renderText(0.7635, 0.29, 0.02,  "Taste 7 Rundumleuchte");
            
		end;
	end;

  if self.isEntered then
    if self.rundumleuchtenKey ~= nil then
      if self.rundumleuchtenAn then
        --g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(Input[self.rundumleuchtenKey]))..": Rundumleuchte aus");
      else
        --g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(Input[self.rundumleuchtenKey]))..": Rundumleuchte ein");
      end;
    end;
  end;



end;

